/*	$Id$	*/

/*-
 * Copyright (c) 1990, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * This code is derived from software contributed to Berkeley by
 * Chris Torek.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#if defined(LIBC_SCCS) && !defined(lint)
__RCSID("$Id$");
#endif /* LIBC_SCCS and not lint */

#include <ctype.h>

#undef isalpha
#undef isupper
#undef islower
#undef isdigit
#undef isxdigit
#undef isalnum
#undef isspace
#undef ispunct
#undef isprint
#undef isgraph
#undef iscntrl
#undef isascii
#undef toascii

extern char _ctype[];

int isalpha (int c)
{
	return (_ctype + 1)[c] & (_U | _L);
}

int isupper (int c)
{
	return (_ctype + 1)[c] & _U;
}

int islower (int c)
{
	return (_ctype + 1)[c] & _L;
}

int isdigit (int c)
{
	return (_ctype + 1)[c] & _N;
}

int isxdigit (int c)
{
	return (_ctype + 1)[c] & _X;
}

int isalnum (int c)
{
	return (_ctype + 1)[c] & (_U | _L | _N);
}

int isspace (int c)
{
	return (_ctype + 1)[c] & _S;
}

int ispunct (int c)
{
	return (_ctype + 1)[c] & _P;
}

int isprint (int c)
{
	return (_ctype + 1)[c] & (_P | _U | _L | _N | _B);
}

int isgraph (int c)
{
	return (_ctype + 1)[c] & (_P | _U | _L | _N);
}

int iscntrl (int c)
{
	return (_ctype + 1)[c] & _C;
}

int isascii (int c)
{
	return !(c & ~0177);
}

int toascii (int c)
{
	return c & 0177;
}
